package com.unipi.talepis.iatriki2023_4;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;
import java.util.Optional;

@RestController
public class AppController {
    @Autowired
    private DrugRepository drugRepository;
    @GetMapping("/drugList")
    public Iterable<Drug> getAllDrugs(){
        return drugRepository.findAll();
    }
    @GetMapping("/find/{id}")
    public Drug findDrugById(@PathVariable Integer id){
        Optional<Drug> drugOptional = drugRepository.findById(id);
        if (drugOptional.isPresent())
            return drugOptional.get();
        else return null;
    }
    @GetMapping("/findN/{tradeName}")
    public Drug findDrugByTradeName(@PathVariable String tradeName){
        return drugRepository.findByTradeName(tradeName);
    }
    @PostMapping("newDrug")
    public Drug addDrug(@RequestBody Map<String,String> body){
        Drug drug = new Drug();
        drug.setTradeName(body.get("tradeName"));
        drug.setMolecule(body.get("molecule"));
        drug.setMarketingManager(body.get("marketingManager"));
        return drugRepository.save(drug);
    }
    @PutMapping("updateDrug")
    public String updateDrug(@RequestBody Map<String,String> body){
        Optional<Drug> drugOptional = drugRepository.findById(Integer.parseInt(body.get("id")));
        if (drugOptional.isPresent()){
            Drug drug = drugOptional.get();
            drug.setTradeName(body.get("tradeName"));
            drug.setMolecule(body.get("molecule"));
            drug.setMarketingManager(body.get("marketingManager"));
            drugRepository.save(drug);
            return "Ok";
        } else return "Error";
    }
}
